#!/usr/bin/env bash
set -euf -o pipefail

if [ "$#" -lt 2 ]; then
	echo "Usage: $0 <unix socket> <command> [command_args]" >&2
	exit 1
fi

SOCKET_PATH=$1
COMMAND=$2
VAR_ARGS=""

shift 2
while [ $# -gt 0 ]
do
	VAR_ARGS="$VAR_ARGS $1"
	shift
done

echo "$COMMAND $VAR_ARGS" | socat - unix-connect:"$SOCKET_PATH"
