#include "../../../agents/refs_prpc/refs_prpc_caller.h"
#include "../../../agents/refs_prpc/refs_prpc_callee.h" // for getNextCall()

#include <ctype.h>
#include <stdio.h>
#include <string.h>

#ifdef __MINGW64__
	#include "windows.h"
#else
	// assert Windows FILETIME structure is defined
	typedef struct _FILETIME {
		int32_t low;
		int32_t high;
	} FILETIME, *PFILETIME, *LPFILETIME;
#endif

#ifndef PRESTRPATH
	#define PRESTRPATH "Z:"
#endif

int main(int argc, char* argv[])
{
	if (argc != 2) {
		fprintf(stderr, "usage: %s <filename>.data", argv[0]);
		return 1;
	}

	/*
	// files present at default state
	char* ads1  = PRESTRPATH"\\foo.txt:ads";
	char* dir1  = PRESTRPATH"\\bar.d";
	char* dir2  = PRESTRPATH"\\fred.d";
	char* file1 = PRESTRPATH"\\foo.txt";
	char* file2 = PRESTRPATH"\\bar.d\\baz.txt";
	char* junc1 = PRESTRPATH"\\junction.d";  // -> PRESTRPATH\bar.d
	char* link1 = PRESTRPATH"\\abslink.d";   // -> PERSTRPATH\bar.d
	char* link2 = PRESTRPATH"\\abslink.txt"; // -> PERSTRPATH\bar.d\baz.txt
	char* link3 = PRESTRPATH"\\bar.d\\rellink.txt"; // -> ..\foo.txt
	char* link4 = PRESTRPATH"\\fred.d\\rellink.d";  // -> ..\bar.d
	(void) (ads1||dir1||dir2||file1||file2||junc1);
	(void) (link1||link2||link3||link4);

	// files created by operations
	char* dir3 = PRESTRPATH"\\extra.d";
	char* dir4 = PRESTRPATH"\\extramoved.d";
	char* dir5 = PRESTRPATH"\\barcopy.d";
	char* file3 = PRESTRPATH"\\hiimnewhere.txt";
	char* file4 = PRESTRPATH"\\bar.d\\foocopy.txt";
	char* file5 = PRESTRPATH"\\fred.d\\movedfoo.txt";
	char* file6 = PRESTRPATH"\\extramoved.d\\henry.txt";
	char* file7 = PRESTRPATH"\\fred.d\\namingishard.txt";
	char* junc2 = PRESTRPATH"\\bar.d\\juncabc.d";
	char* junc3 = PRESTRPATH"\\bar.d\\junccc.d";
	char* link5 = PRESTRPATH"\\missinglink.txt";
	cHar* link6 = PRESTRPATH"\\bar.d\\foundlink.txt";
	char* link7 = PRESTRPATH"\\bar.d\\imalinkclickme.txt";
	char* link8 = PRESTRPATH"\\bar.d\\endangered.txt";
	(void) (dir3||dir4||dir5||file3||file4||file5||file6||file7||junc2);
	(void) (junc3||link5||link6||link7||link8);

	// timestamps used
	FILETIME t1 = { 1337, 0x0 };
	FILETIME t2 = { 4242, 0x0 };
	(void)t1; (void)t2;

	// operations
	// complex operations enable later
	createDirectory(dir3, NULL);      // directory create
	moveFile(dir3, dir4); dir3=dir4;  // directory move
	copyDirectory(dir1, dir5);        // directory copy
	setFileAttributes(dir4, 0x4);     // directory attributes
	createFile(file3, 0x4, NULL);        // file create
	setFileTime(file1, &t1,&t1,&t1);     // directory timestamp
	copyFile(file1, file4);              // file copy
	copyFile(file1, file5);              // file copy
	moveFile(file1, file6); file1=file6; // file move
	copyFile(file6, file7);           // file copy
	deleteFile(file2); file2=NULL;    // file delete
	lockFile(file7,3,5);              // file lock
	unlockFile(file7,3,5);            // file unlock (exact same parameters)
	setFileTime(file5, &t2,&t2,&t2);  // file timestamp
	setEndOfFile(file6, 42);          // file size
	// FIXME ERROR: required privilege not held
	//setFileValidData(file7, 17);      // file size
	setFileAttributes(file6, 0x4);    // file attributes
	createJunction(junc2, dir5);         // junction create
	// TODO implement copyJunction
	//copyJunction(junc1, junc2);            // junction copy
	moveFile(junc1, junc3); junc1=junc3; // junction move
	removeDirectory(junc3);            // junction delete
	createSymLink(link5, file6, 0); // symlink create
	moveFile(link5, link7); link5=link7; // symlink move
	copyFile(link7, link8);           // symlink copy
	deleteFile(link8); link8=NULL; // symlink delete
	setFileTime(link7, &t1,&t1,&t1);  // symlink timestamp
	setFileAttributes(link7, 0x4);    // symlink attributes
	*/

	listDirectory("Z:\\folder1\\");
	listDirectory("Z:\\folder2\\");
	readFile("Z:\\fffffffffffffff.txt");

	ReFSCall* payload = getPayload();
	//
	FILE* f = fopen(argv[1], "w");
	if (!f) {
		perror("fopen");
		return 1;
	}

	fwrite(payload, 1, getPayloadSize(), f);
	fflush(f);
	fclose(f);
}
