#include "../../../agents/refs_prpc/refs_prpc_caller.h"
#include "../../../agents/refs_prpc/refs_prpc_callee.h" // for getNextCall()

#include <ctype.h>
#include <stdio.h>
#include <string.h>

int main(int argc, char* argv[])
{
	if (argc != 2) {
		fprintf(stderr, "usage: %s <filename>.json", argv[0]);
		return 1;
	}
	// calls
	/*
	createDirectory("Z:\\blab.d");
	createFile("Z:\\blab.d\\blub.txt", 0x0);
	createSymLink("Z:\\link.txt", "Z:\\blab.d\\blub.txt", 1);
	setFileValidData("Z:\\test.txt", 0xaabbccddeeff0011);
	*/

	// write payload to file
	FILE* f = fopen(argv[1], "w");
	if (!f) {
		perror("fopen");
		return 1;
	}
	ReFSCall* payload = getPayload();
	//
	fprintf(f, "{\n\t\"comment\":\"Use 'python -m json.tool' to enhance readability\",\n\t\"calls\":{\n");
	//
	ReFSCall* call = payload;
	int callnr = 0;
	while (!callIsListEnd(call)) {
		fprintf(f, "\"call%d\":{\"id\":%d,\"params\":{", callnr++, call->id);
		ReFSCallParam* param = call->params;
		int i = 0;
		while (!paramIsListEnd(param)) {
			fprintf(f,  "\"param%d\":{\"size\":%d,\"value\":\"", i++, param->memsize);
			// check if all characters are printable (string)
			int printable = 1;
			for (int i = 0; i < param->memsize-1; ++i)
				if (!isprint(param->mem[i])) {
					printable = 0;
					break;
				}
			if (param->mem[param->memsize-1] != '\0')
				printable = 0;
			if (printable) {
				// print string, escape slashes
				for (int i = 0; i < param->memsize-1; ++i)
					if (param->mem[i] != '\\')
						fprintf(f, "%c", param->mem[i]);
					else
						fprintf(f, "\\\\");
			} else {
				fprintf(f, "0x");
				for (int i = param->memsize-1; i>=0; --i)
					fprintf(f, "%02hhx", param->mem[i]);
			}
			fprintf(f, "\"}");
			param = getNextParam(param);
			if (!paramIsListEnd(param))
				fprintf(f,",");
		}
		fprintf(f, "}}");
		call = getNextCall(call);
		if (!callIsListEnd(call))
			fprintf(f,",");
	}
	fprintf(f, "}}\n");
	fclose(f);
}

